import es
import cmdlib
import popuplib
import playerlib
import vecmath
from gamethread import queue
from gamethread import delayed
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "Universal Soccer Script"
info.version = "2.00"
info.url = "http://addons.eventscripts.com/addons/view/soccer"
info.basename = "soccer"
info.author = "chrismrulz"
es.set('uss_version', info.version)
es.makepublic('uss_version')

def optionssay(userid, args):
	popups['optionsmenu'].send(userid)

def navmenu(userid, choice, popupname):
	popups[popupname].unsend(userid)
	popups[choice.replace('goto', '')].send(userid)

def setoption(userid, choice, popupname):
	if(str(choice).startswith('goto')):
		navmenu(userid, choice, popupname)
	else:
		steamid = es.getplayersteamid(userid)
		global players
		if(steamid not in players):
			players[steamid] = {}
		players[steamid][popupname] = choice

popups = {}
popups['optionsmenu'] = popuplib.easymenu('optionsmenu', None, navmenu)
popups['optionsmenu'].settitle('Options')
popups['optionsmenu'].addoption('gotoknifemenu', 'Knifing')
popups['optionsmenu'].addoption('gotosprintmenu', 'Sprinting')
popups['optionsmenu'].addoption('gotospawnmenu', 'Spawning')

popups['knifemenu'] = popuplib.easymenu('knifemenu', None, navmenu)
popups['knifemenu'].settitle('Options>Knifing')
popups['knifemenu'].addoption('gotoknifemsgmode', 'Message Delivery')
popups['knifemenu'].addoption('gotoknifesounds', 'Warning Sounds')
popups['knifemenu'].addoption('gotooptionsmenu', 'Back..')

popups['sprintmenu'] = popuplib.easymenu('sprintmenu', None, navmenu)
popups['sprintmenu'].settitle('Options>Sprinting')
popups['sprintmenu'].addoption('gotosprintmsgs', 'Messages')
popups['sprintmenu'].addoption('gotosprintmsgmode', 'Message Delivery')
popups['sprintmenu'].addoption('gotooptionsmenu', 'Back..')

popups['spawnmenu'] = popuplib.easymenu('spawnmenu', None, navmenu)
popups['spawnmenu'].settitle('Options>Spawning')
popups['spawnmenu'].addoption('gotospawnlook', 'View Enemy Goals')
popups['spawnmenu'].addoption('gotooptionsmenu', 'Back..')

popups['knifemsgmode'] = popuplib.easymenu('knifemsgmode', None, setoption)
popups['knifemsgmode'].settitle('Options>Knifing>Message Delivery')
popups['knifemsgmode'].addoption(0, 'Popups on the left')
popups['knifemsgmode'].addoption(1, 'Popups on the bottom-center')
popups['knifemsgmode'].addoption(2, 'Chat messages')
popups['knifemsgmode'].addoption('gotoknifemenu', 'Back..')

popups['knifesounds'] = popuplib.easymenu('knifesounds', None, setoption)
popups['knifesounds'].settitle('Options>Knifing>Warning Sounds')
popups['knifesounds'].addoption(0, 'Enabled')
popups['knifesounds'].addoption(1, 'Disabled')
popups['knifesounds'].addoption(2, 'Enabled only for !knifecount')
popups['knifesounds'].addoption('gotoknifemenu', 'Back..')

popups['sprintmsgs'] = popuplib.easymenu('sprintmsgs', None, setoption)
popups['sprintmsgs'].settitle('Options>Sprinting>Messages')
popups['sprintmsgs'].addoption(0, 'Off')
popups['sprintmsgs'].addoption(1, 'Normal')
popups['sprintmsgs'].addoption(2, 'Extended')
popups['sprintmsgs'].addoption('gotosprintmenu', 'Back..')

popups['sprintmsgmode'] = popuplib.easymenu('sprintmsgmode', None, setoption)
popups['sprintmsgmode'].settitle('Options>Sprinting>Message Delivery')
popups['sprintmsgmode'].addoption(0, 'Popups on the left')
popups['sprintmsgmode'].addoption(1, 'Popups on the bottom-center')
popups['sprintmsgmode'].addoption(2, 'Chat messages')
popups['sprintmsgmode'].addoption('gotosprintmenu', 'Back..')

popups['spawnlook'] = popuplib.easymenu('spawnlook', None, setoption)
popups['spawnlook'].settitle('Options>Spawning>View Enemy Goals')
popups['spawnlook'].addoption(0, 'Off')
popups['spawnlook'].addoption(1, 'On')
popups['spawnlook'].addoption('gotospawnmenu', 'Back..')

def load():
	es.msg('#Green', 'Universal Soccer Script On - by Toph')
	if(es.exists('clientcommand', 'options') != 1):
		cmdlib.registerClientCommand('options', optionssay, 'Shows the player options menu')
	if(es.exists('saycommand', '!options') != 1):
		cmdlib.registerSayCommand('!options', optionssay, 'Shows the player options menu')
	getconfig()
	initvars()
	global isnm
	global commentator
	global deaths
	isnm = 1
	commentator = int(config.get("Commentator", "enabled"))
	deaths = int(config.get("Commentator", "deaths"))

def unload():
	unloadall()
	savepvars()
	global popups
	for item in popups:
		popups[item].delete()
	popups.clear()
	cmdlib.unregisterClientCommand('options')
	cmdlib.unregisterSayCommand('!options')
	es.msg('#Green', 'Universal Soccer Script Off')

def unloadall():
	if(checkbox in es.addons.TickListeners):
		es.addons.unregisterTickListener(checkbox)
	for script in config.items('Core'):
		if(int(script[1]) > 1):
			queue(es.unload, 'soccer/%s%s' % (script[0].replace('_enabled', '') , script[1]))
		else:
			queue(es.unload, 'soccer/%s' % script[0].replace('_enabled', ''))

def es_map_start(event_var):
	global mapname
	global isnm
	isnm = 1
	unloadall()
	mapname = event_var['mapname']
	getcoords(mapname)
	savepvars()

def toload(scriptname):
	return int(config.get('Core', '%s_enabled' % scriptname))

def player_death(event_var):
	global newround
	newround = 0
	if(es.getlivingplayercount(2) == 0 or es.getlivingplayercount(3) == 0):
		global roundfinished
		roundfinished = 1
	if(commentator == 1 and deaths == 1):
		es.msg('#multi', '#greenPlayer#lightgreen %s #greenhas been injured.' % event_var['es_username'])

def round_start(event_var):
	global roundfinished
	global newround
	roundfinished = 0
	newround = 1
	if(isnm == 1):
		global mapname
		if('ka_soccer' in mapname):
			es.addons.registerTickListener(checkbox)
			es.msg('#Green', 'This server is running Universal Soccer Script v%s by Toph.' % es.server_var['uss_version'])
			for script in config.items('Core'):
				if(int(script[1]) == 1):
					queue(es.load, 'soccer/%s' % script[0].replace('_enabled', ''))
				elif(int(script[1]) != 0):
					queue(es.load, 'soccer/%s%s' % (script[0].replace('_enabled', ''), script[1]))
			if(toload('soccermap') == 1):
				queue(es.doblock, 'soccer/soccermap/doloop')
			if(toload('soccerautoref') == 1 and int(config.get('Ref', 'refmode')) == 1):
				queue(es.doblock, 'soccer/soccerautoref/startptime')
		global isnm
		isnm = 0

def multipleReplace(text, wordDict):
	for key in wordDict:
		text = text.replace(key, wordDict[key])
	return text

def initvars():
	global roundfinished
	global newround
	global players
	global refvars
	global stats
	global functions
	roundfinished = 0
	newround = 0
	functions = {}
	boxes = []
	for cvar in config.items('Core'):
		es.set(cvar[0], cvar[1])
		es.makepublic(cvar[0])
	players = {}
	refvars = {}
	stats = {}
	stats['@Restricted'] = []
	from os import path
	pvarsfile = es.getAddonPath('soccer') + '/playervars.cpickle'
	if(path.exists(pvarsfile)):
		from cPickle import load
		readpvars = open(pvarsfile, 'r')
		players = load(readpvars)
		readpvars.close()
	wordDic = {
	'soccermod 2008': 'UniversalSoccerScript',
	'soccermod 2009': 'UniversalSoccerScript',
	'soccer mod 2008': 'Universal Soccer Script',
	'soccer mod 2009': 'Universal Soccer Script',
	'soccermod': 'UniversalSoccer',
	'soccer mod': 'Universal Soccer'}
	hostname = es.getString('hostname').lower()
	if('soccer' in hostname and 'mod' in hostname):
		es.set('hostname', multipleReplace(hostname, wordDic))

def restrictstat(name):
	if(name not in stats['@Restricted']):
		stats['@Restricted'].append(name)

def unrestrictstat(name):
	if(name not in stats['@Restricted']):
		return False
	else:
		stats['@Restricted'].remove(name)
		return True

def addsound(sound):
	es.stringtable('downloadables', 'sound/' + sound)

def adddownloads(downloads):
	for download in downloads:
		es.stringtable('downloadables', download)

def slay(userid):
	es.emitsound("player", userid, "weapons/hegrenade/explode3.wav", '1.0', '0.6')
	es.sexec(userid, 'kill')

def savepvars():
	from cPickle import dump
	writepvars = open(es.getAddonPath('soccer') + '/playervars.cpickle', 'w')
	dump(players, writepvars)
	writepvars.close()

def incstat(steamid, name, stat):
	if(steamid not in stats):
		stats[steamid] = {}
		stats[steamid]['Name'] = name
		stats[steamid][stat] = 1
	elif(stat not in stats[steamid]):
		stats[steamid][stat] = 1
	elif(stats[steamid][stat] != 0):
		stats[steamid][stat] += 1
	else:
		stats[steamid][stat] = 1

def dofire(p1, p2, p3, p4 = "", p5 = ""):
	es.server.cmd('es_xfire %i %s %s [%s] [%s]' % (p1, p2, p3, p4, p5))

def getconfig():
	import ConfigParser
	global config
	config = ConfigParser.RawConfigParser()
	config.read(es.server_var['eventscripts_gamedir'] + '/cfg/soccer.ini')

def hook(function, name):
	if name not in functions:
		functions[name] = []
	functions[name].append(function)

def firefunc(name, args):
	if name in functions:
		for func in functions[name]:
			func(args)

def checkbox():
	for userid in es.getUseridList():
		for box in boxes:
			if(str(playerlib.getPlayer(userid).isdead) in str(box.dead) and str(es.getplayerteam(userid)) in str(box.team) and es.getplayerlocation(userid) in box):
				firefunc(box.name, userid)

class Box:
	def __init__(self, dead, team, name, mincoord, maxcoord):
		self.dead = dead
		self.team = team
		self.name = name
		self.mincoord = mincoord
		self.maxcoord = maxcoord
	def __contains__(self, location):
		if(vecmath.isbetweenRect(location, self.mincoord, self.maxcoord)):
			return True

def getcoords(mapname):
	global goalhp
	global goaldisty
	global pbx
	global pbz
	global pbcty
	global pbty
	global newpbcty
	global newpbty
	global halfline
	global goalxm
	global goalxp
	global tgoalym
	global tgoalyp
	global ctgoalym
	global ctgoalyp
	global ballname
	global tgoalviewx
	global tgoalviewy
	global ctgoalviewx
	global ctgoalviewy
	global goalviewz
	global boxes
	boxes = []
	soccerautoref_enabled = config.get("Core", "soccerautoref_enabled")
	soccergoalie_enabled = config.get("Core", "soccergoalie_enabled")
	soccergoalslay_enabled = config.get("Core", "soccergoalslay_enabled")
	soccerstats_enabled = config.get("Core", "soccerstats_enabled")
	healthmode = config.get("Health", "healthmode")
	if("ka_soccer_20" in mapname):
		if("2007" in mapname):
			goalhp = 300
			ballname = "football"
			if(soccerautoref_enabled != 0 or soccergoalie_enabled != 0):
				goaldisty = 320
				pbx = 0
				pbz = 82
				pbty = 1370
				pbcty = -1370
			if(healthmode > 2):
				tgoalviewx = 4.101076
				tgoalviewy = -1396.985474
				ctgoalviewx = -4.101076
				ctgoalviewy = 1787.664185
				goalviewz = 185
			if(soccergoalie_enabled != 0 or soccerstats_enabled == 1):
				halfline = 0
				goalxm = -675
				goalxp = 675
				tgoalym = 1181
				tgoalyp = 1964
				ctgoalym = -1964
				ctgoalyp = -1181
				boxes.append(Box(0, 23, 'thefield', (-1262.968750,-2030.968750,64.031250), (1262.968750,2030.968750,64.031250)))
				boxes.append(Box(0, 2, 'goalbox1', (-383,1539,0), (383,1964,5000)))
				boxes.append(Box(0, 3, 'goalbox2', (-383,-1964,0), (383,-1539,5000)))
			if(soccergoalslay_enabled != 0):
				boxes.append(Box(0, 23, 'goaltop1', (150,1817,188), (-151,1785,192)))
				boxes.append(Box(0, 23, 'goaltop2', (-150,-1784,192), (151,-1815,188)))
		elif("_sansiro" in mapname):
			goalhp = 250
			ballname = "ballon"
			if(soccerautoref_enabled != 0 or soccergoalie_enabled != 0):
				goaldisty = 320
				pbx = 0
				pbz = 150
				pbty = 1012.729736
				pbcty = -1012.729736
			if(healthmode > 2):
				tgoalviewx = 0
				tgoalviewy = -1396.985474
				ctgoalviewx = 0
				ctgoalviewy = 1396.985474
				goalviewz = 105.031250
			#if(soccergoalie_enabled != 0 or soccerstats_enabled == 1):
				#halfline = 3328
				#goalxm = 5538
				#goalxp = 6746
				#tgoalym = 4162
				#tgoalyp = 4772
				#ctgoalym = 1877
				#boxes.append(Box(0, 23, 'thefield', (4880.031250, 1680.005737, 1024.031250), (7407.968750, 4975.968750, 1024.031250)))
				#boxes.append(Box(0, 2, 'goalbox1', (5830, 4520, 0), (6454, 4772, 5000)))
				#boxes.append(Box(0, 3, 'goalbox2', (5830, 1877, 0), (6454, 2136, 5000)))
			#if(soccergoalslay_enabled != 0):
				#boxes.append(Box(0, 23, 'goaltop1', (5998, 4705, 1125), (6284, 4772, 1130)))
				#boxes.append(Box(0, 23, 'goaltop2', (5998, 1877, 1125), (6284, 1951, 1130)))
		else:
			goalhp = 250
			ballname = "ballon"
			if(soccerautoref_enabled != 0 or soccergoalie_enabled != 0):
				goaldisty = 320
				pbx = 6144
				pbz = 1041
				pbty = 4344
				pbcty = 2312
			if(healthmode > 2):
				tgoalviewx = 6148.051270
				tgoalviewy = 1935.321167
				ctgoalviewx = 6148.051270
				ctgoalviewy = 4717.780762
				goalviewz = 1129.031250
			if(soccergoalie_enabled != 0 or soccerstats_enabled == 1):
				halfline = 3328
				goalxm = 5538
				goalxp = 6746
				tgoalym = 4162
				tgoalyp = 4772
				ctgoalym = 1877
				ctgoalyp = 2494
				boxes.append(Box(0, 23, 'thefield', (4880.031250, 1680.005737, 1024.031250), (7407.968750, 4975.968750, 1024.031250)))
				boxes.append(Box(0, 2, 'goalbox1', (5830, 4520, 0), (6454, 4772, 5000)))
				boxes.append(Box(0, 3, 'goalbox2', (5830, 1877, 0), (6454, 2136, 5000)))
			if(soccergoalslay_enabled != 0):
				boxes.append(Box(0, 23, 'goaltop1', (5998, 4705, 1125), (6284, 4772, 1130)))
				boxes.append(Box(0, 23, 'goaltop2', (5998, 1877, 1125), (6284, 1951, 1130)))
	else:
		goalhp = 250
		ballname = "ballon"
		if(soccerautoref_enabled != 0 or soccergoalie_enabled != 0):
			goaldisty = 320
			pbx = 6144
			pbz = 1041
			pbty = 4344
			pbcty = 2312
		if(healthmode > 2):
			tgoalviewx = 0
			tgoalviewy = -1389.929199
			ctgoalviewx = 0
			ctgoalviewy = 1389.929199
			goalviewz = 105.031250
		if(soccergoalie_enabled != 0 or soccerstats_enabled == 1):
			halfline = 0
			goalxm = -602
			goalxp = 602
			tgoalym = 827
			tgoalyp = 1539
			ctgoalym = -1539
			ctgoalyp = -827
			boxes.append(Box(0, 23, 'thefield', (-1263.968750, -1647.968750, 0.031250), (1263.968750, 1647.968750, 57.624115)))
			boxes.append(Box(0, 2, 'goalbox1', (-310, 1185, 0), (310, 1539, 5000)))
			boxes.append(Box(0, 3, 'goalbox2', (-310, -1539, 0), (310, -1185, 5000)))
		if(soccergoalslay_enabled != 0):
			boxes.append(Box(0, 23, 'goaltop1', (142, 1453, 102), (-146, 1370, 106)))
			boxes.append(Box(0, 23, 'goaltop2', (-146, -1453, 102), (142, -1370, 106)))
	newpbcty = pbcty
	newpbty = pbty
	if(pbcty < pbty):
		newpbcty -= goaldisty
		newpbty += goaldisty
	else:
		newpbcty += goaldisty
		newpbty -= goaldisty